---
title: CSSMathValue
slug: Web/API/CSSMathValue
tags:
  - API
  - CSS Typed Object Model API
  - CSSMathValue
  - Experimental
  - Houdini
  - Interface
  - Reference
---
<div>{{draft}}{{APIRef("CSS Typed Object Model API")}}{{SeeCompatTable}}</div>

<p class="summary">The <strong><code>CSSMathValue</code></strong> interface of the {{domxref('CSS Typed Object Model API','','',' ')}} a base class for classes representing complex numeric values.</p>

<h2 id="Interfaces_based_on_CSSMathValue">Interfaces based on CSSMathValue</h2>

<p>Below is a list of interfaces based on the CSSMathValue interface.</p>

<div class="index">
<ul>
 <li>{{domxref('CSSMathInvert')}}</li>
 <li>{{domxref('CSSMathMax')}}</li>
 <li>{{domxref('CSSMathMin')}}</li>
 <li>{{domxref('CSSMathNegate')}}</li>
 <li>{{domxref('CSSMathProduct')}}</li>
 <li>{{domxref('CSSMathSum')}}</li>
</ul>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('CSSMathValue.operator')}}</dt>
 <dd>Indicates the operator that the current subtype represents.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p>No</p>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>We create an element with a <code><a href="/en-US/docs/Web/CSS/width">width</a></code> determined using a <code><a href="/en-US/docs/Web/CSS/calc">calc()</a></code> function, then <code><a href="/en-US/docs/Web/API/Console/log">console.log()</a></code> the <code>operator</code>.</p>

<pre class="brush: html">&lt;div&gt;has width&lt;/div&gt;
</pre>

<p>We assign a <code>width</code> with a calculation</p>

<pre class="brush: css">div {
  width: calc(30% - 20px);
}</pre>

<p>We add the JavaScript</p>

<pre class="brush: js">const styleMap = document.querySelector('div').computedStyleMap();

console.log( styleMap.get('width') );                  // CSSMathSum {values: CSSNumericArray, operator: "sum"}
console.log( styleMap.get('width').operator );         // 'sum'
console.log( styleMap.get('width').values[1].value );  // -20
</pre>

<p>{{EmbedLiveSample("Examples", 120, 300)}}</p>

<p>The <code>CSSMathValue.operator</code> returns '<code>sum</code>' because <code>styleMap.get('width').values[1].value );</code> is <code>-20</code>: adding a negative number.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Typed OM','#complex-numeric','CSSMathValue')}}</td>
   <td>{{Spec2('CSS Typed OM')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSMathValue")}}</p>
